;=======================================================================
; tm1638cc_delay.inc
; delay routines for tm1638 library
; 
; written by Ralf Jardon (cosmicos@gmx.net), May-July 2017
;
; License: GNU GENERAL PUBLIC LICENSE, Version 3, 29 June 2007
;
; Version: 0.1
;=======================================================================

.equ	c1us	= (1*fck)/4000 - 1
.equ	c10ms	= (10*fck)/4 - 1
.equ	c50ms	= (500*fck)/4 - 1


Delay1s:
		push	akku
		ldi   	akku, 255
dloop:
		rcall	Delay10ms
		dec		akku
		brne	dloop
		pop 	akku
		ret


Delay100ms:
		push	akku
		ldi   	akku, 10
d100loop:
		rcall	Delay10ms
		dec		akku
		brne	d100loop
		pop		akku
		ret


Delay1us:
		push	r24
		push	r25 			; 1 us routine
		ldi R25,HIGH(c1us)
		ldi R24,LOW(c1us)
		rjmp Delayloop


Delay50ms: 			
		push	r24
		push	r25				; 50 ms routine
		ldi R25,HIGH(c50ms)
		ldi R24,LOW(c50ms)
		rjmp Delayloop		


Delay10ms:
		push	r24
		push	r25				; 10 ms routine
		ldi R25,HIGH(c10ms)
		ldi R24,LOW(c10ms)
		rjmp Delayloop


;
; delayloop, awaits values in R25:R24
;

Delayloop:
	sbiw R24,1
	brne Delayloop
		pop		r25
		pop		r24
	ret
